<%-- $This file is distributed under the terms of the license in /doc/license.txt$ --%>

<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>
<%@ page isErrorPage="true" %>
<%@ page import="com.oreilly.servlet.ServletUtils,edu.cornell.mannlib.vitro.webapp.web.*" %>
<%@page import="edu.cornell.mannlib.vitro.webapp.controller.VitroRequest"%>
<%@page import="edu.cornell.mannlib.vitro.webapp.beans.ApplicationBean"%>
<%@page import="edu.cornell.mannlib.vitro.webapp.beans.Portal"%>
<%
            VitroRequest vreq = new VitroRequest(request);
            ApplicationBean appBean = vreq.getAppBean();
            Portal portal = vreq.getPortal();

            String themeDir = portal!=null ? portal.getThemeDir() : Portal.DEFAULT_THEME_DIR_FROM_CONTEXT;                        
                        
            
            request.setAttribute("bodyJsp", "/errorbody.jsp");
            request.setAttribute("title", "Error");
            request.setAttribute("css", "");
            request.setAttribute("portalBean", portal);
            request.setAttribute("appBean", appBean);            
            request.setAttribute("themeDir", themeDir);            
            %>
            
<jsp:include page="/templates/page/doctype.jsp"/>
<head>
  <jsp:include page="/templates/page/headContent.jsp"/>
</head>
<body> <!-- generated by error.jsp -->
<div id="wrap">
    <jsp:include page="/${themeDir}jsp/identity.jsp" flush="true"/>
    
    <div id="contentwrap">
    
        <jsp:include page="/${themeDir}jsp/menu.jsp" flush="true"/>
                
       
        <p>There was an error in the system; please try again later.</p>
        
        <div>
            <h3>Exception: </h3><%= exception %>
        </div>

    <div>    
    <% try{ %>      
       <h3>Trace:</h3><pre><%= ServletUtils.getStackTraceAsString(exception) %></pre>
    <% }catch (Exception e){ %>
       No trace is available.
    <% } %>
    </div>

    <div>
    <% try{ %>      
    <h3>Request Info:</h3><%= MiscWebUtils.getReqInfo(request) %>
    <% }catch (Exception e){ %>
       No request information is available.
    <% } %>
    </div>
    
    
    </div> <!-- contentwrap -->
    <jsp:include page="/${themeDir}jsp/footer.jsp" flush="true"/>
</div> <!-- wrap -->
</body>
</html>
